/*
NOME: 0002_GERSTPO_EXPORTA_TABELA_NF.SQL

DESCRIO: Procedimento para gerao das NFs em tabela do cliente.

CRIAO: 09/10/2006 - Cristiane Faria dos Santos

@C:\web_585\sql\end_conv\oracle\clientes\cch\0002_GERSTPO_EXPORTA_TABELA_NF.SQL

RAISE_APPLICATION_ERROR(-20501, '' , TRUE);
*/

CREATE OR REPLACE PROCEDURE EXPORTA_TABELA_NF(
     P_CDFILIAL  IN FILIAL.CDFILIAL%TYPE,
     P_DTINICIAL IN NOTAFISCAL.DTENTRSAID%TYPE)
AS
   V_LOG         VARCHAR2(01);
   V_BODEGA      VARCHAR2(04);
   V_IMPORTA     VARCHAR2(01);
   V_LINEA       VARCHAR2(04);
   V_CENTRO      VARCHAR2(20);
   V_CENTRODEST  VARCHAR2(20);
   V_TOTAITENS   NUMBER;
BEGIN
   /* Comando para alterar o formato nmerico da sesso passando a ser separado as casas decimais atravs de ponto (.) */
   EXECUTE IMMEDIATE 'alter session set nls_numeric_characters = '||''''||'.,'||'''';

   /* Verificao dos documentos de Entrada */
   FOR C_ENTRADA IN (SELECT
                        N.CDFILIAL,
                        N.NRLANCTONF,
                        '' AS NRLANCESTQ,
                        N.CDFILIAL||N.NRLANCTONF||TP.CDEXTIPOOPER AS ID,
                        TP.CDEXTIPOOPER,
                        N.CDEMPRESA AS EMPRESA,
                        N.CDSERIEENTR,
                        SUBSTR(N.NRINSJURNF,1,20) AS RUT,
                        CT.CDCONTREDU AS CUENTA_CONTABLE,
                        DECODE(E.CDPAIS, '0054', SUBSTR(N.CDSERIEENTR,2,4)||LPAD(N.NRNOTAFISC, 8, '0'), DECODE(E.CDPAIS, '0057', SUBSTR(UPPER(N.DSCDFISOPENF),1,20), N.NRNOTAFISC)) AS NRNOTAFISC,
                        N.DTEMISSAO,
                        N.DTENTRSAID,
                        MIN(C.DTORIGVENPAG) AS DATAVENC,
                        ROUND(N.VRNOTAFISC,2) AS VRNOTAFISC,
                        N.CDFILIRECE,
                        N.CDFILIEMIT,
                        ALMOX.IDALMOXARIFE,
                        ALMOX.CDALMOXARIFE,
                        E.CDPAIS,
                        ED.CDPAIS AS CDPAISDEST,
                        N.CDTIPOOPER,
                        DECODE(E.CDPAIS, '0057', EF.CDMUNICIPIO, '') AS CDMUNICIPIO,
                        DECODE(E.CDPAIS, '0057', SUBSTR(EF.NRCEPFORN,1,6), '') AS NRCEPFORN,
                        TP.IDATUESTTPOP
                     FROM
                        NOTAFISCAL N, CONTAPAGAR C, TIPOOPERAC TP, FORNECEDOR F,
                        ENDEFILI E, ENDEFILI ED, CONTCTBL CT, ENDEFORN EF,
                        (SELECT N.CDFILIAL, N.NRLANCTONF, 'S' AS IDALMOXARIFE, MAX(I.CDALMOXARIFE) AS CDALMOXARIFE
                         FROM NOTAFISCAL N, ITEMPRODUTO I
                         WHERE
                            (N.CDFILIRECE   = P_CDFILIAL)                               AND
                            (N.IDENTRSAIDOP = 'E')                                      AND
                            (N.DTENTRSAID   = P_DTINICIAL)                              AND
                            (N.CDTIPOOPER    NOT IN  ('09','10'))                       AND
                            (N.IDSISTEMA IN ('DFE','EST') OR N.IDSISTEMA IS NULL)       AND
                            (I.CDFILIAL     = N.CDFILIAL)                               AND
                            (I.NRLANCTONF   = N.NRLANCTONF)                             AND
                            (I.CDALMOXARIFE <> ' ')
                         GROUP BY
                            N.CDFILIAL, N.NRLANCTONF, 'S'
                        ) ALMOX
                     WHERE
                        (N.CDFILIRECE        = P_CDFILIAL)                               AND
                        (N.IDENTRSAIDOP      = 'E')                                      AND
                        (N.DTENTRSAID        = P_DTINICIAL)                              AND
                        (N.CDTIPOOPER    NOT IN  ('09','10'))                            AND
                        (N.IDSISTEMA IN ('DFE','EST') OR N.IDSISTEMA IS NULL)            AND
                        (N.CDFILIAL          = C.CDFILIAL(+))                            AND
                        (N.NRLANCTONF        = C.NRLANCTONF(+))                          AND
                        NOT EXISTS (SELECT CDFILIAL FROM LANCTOESTOQ L
                                    WHERE (L.CDFILIAL   = N.CDFILIAL)    AND
                                          (L.NRLANCTONF = N.NRLANCTONF)  AND
                                          (L.IDTPLANCTO  = '2'))                         AND
                        (N.CDFILIAL          = ALMOX.CDFILIAL (+))                       AND
                        (N.NRLANCTONF        = ALMOX.NRLANCTONF (+))                     AND
                        (TP.IDENTRSAIDOP     = N.IDENTRSAIDOP)                           AND
                        (TP.CDTIPOOPER       = N.CDTIPOOPER)                             AND
                        (F.CDFORNECED (+)    = N.CDFORNECED)                             AND
                        (F.CDCONTCTBL        = CT.CDCONTCTBL (+))                        AND
                        (E.CDFILIAL (+)      = N.CDFILIRECE)                             AND
                        (E.IDTPENDEFILI (+)  = 'P')                                      AND
                        (ED.CDFILIAL (+)     = N.CDFILIEMIT)                             AND
                        (ED.IDTPENDEFILI (+) = 'P')                                      AND

                        (N.CDFORNECED        = EF.CDFORNECED (+))                        AND
                        (EF.IDTPENDEFORN (+) = 'P')
                     GROUP BY
                        N.CDFILIAL,
                        N.NRLANCTONF,
                        '',
                        N.CDFILIAL||N.NRLANCTONF||TP.CDEXTIPOOPER,
                        TP.CDEXTIPOOPER,
                        N.CDEMPRESA,
                        N.CDSERIEENTR,
                        SUBSTR(N.NRINSJURNF,1,20),
                        CT.CDCONTREDU,
                        DECODE(E.CDPAIS, '0054', SUBSTR(N.CDSERIEENTR,2,4)||LPAD(N.NRNOTAFISC, 8, '0'), DECODE(E.CDPAIS, '0057', SUBSTR(UPPER(N.DSCDFISOPENF),1,20), N.NRNOTAFISC)),
                        N.DTEMISSAO,
                        N.DTENTRSAID,
                        N.VRNOTAFISC,
                        N.CDFILIRECE,
                        N.CDFILIEMIT,
                        ALMOX.IDALMOXARIFE,
                        ALMOX.CDALMOXARIFE,
                        E.CDPAIS,
                        ED.CDPAIS,
                        N.CDTIPOOPER,
                        DECODE(E.CDPAIS, '0057', EF.CDMUNICIPIO, ''),
                        DECODE(E.CDPAIS, '0057', SUBSTR(EF.NRCEPFORN,1,6), ''),
                        TP.IDATUESTTPOP

                     UNION ALL

                     SELECT
                        A.CDFILIAL,
                        A.NRLANCTONF,
                        A.NRLANCESTQ,
                        A.CDFILIAL||A.NRLANCESTQ||TP.CDEXTIPOOPER AS ID,
                        TP.CDEXTIPOOPER,
                        FR.CDEMPRESA AS EMPRESA,
                        '' AS CDSERIEENTR,
                        '' AS RUT,
                        '' AS CUENTA_CONTABLE,
                        '' AS NRNOTAFISC,
                        NULL  AS DTEMISSAO,
                        A.DTLANCESTQ AS DTENTRSAID,
                        NULL  AS DATAVENC,
                        ROUND(SUM(I.VRTOTLANCTO),2) AS VRNOTAFISC,
                        A.CDFILIMOVI AS CDFILIRECE,
                        '' AS CDFILIEMIT,
                        'S' AS IDALMOXARIFE,
                        CDALMOXENTR AS CDALMOXARIFE,
                        E.CDPAIS,
                        '' AS CDPAISDEST,
                        '' AS CDTIPOOPER,
                        '' AS CDMUNICIPIO,
                        '' AS NRCEPFORN,
                        '' AS IDATUESTTPOP
                     FROM
                        LANCTOESTOQ A, ITLANCTOEST I, CTRLMOVIESTQ C,
                        TIPOOPERAC TP, FILIAL FR, ENDEFILI E
                     WHERE
                        (A.CDFILIMOVI      = P_CDFILIAL)            AND
                        (A.IDTPLANCTO      = '2')                   AND
                        (A.DTLANCESTQ      = P_DTINICIAL)           AND
                        (A.CDFILIAL        = I.CDFILIAL)            AND
                        (A.NRLANCESTQ      = I.NRLANCESTQ)          AND
                        (C.CDFILIALENTR    = A.CDFILIAL)            AND
                        (C.NRLANESTENTR    = A.NRLANCESTQ)          AND
                        (TP.IDENTRSAIDOP   = 'E')                   AND
                        (TP.CDTIPOOPER     = '90')                  AND
                        (FR.CDFILIAL       = A.CDFILIMOVI)          AND
                        (E.CDFILIAL        = A.CDFILIMOVI)          AND
                        (E.IDTPENDEFILI    = 'P')
                     GROUP BY
                        A.CDFILIAL,
                        A.NRLANCTONF,
                        A.NRLANCESTQ,
                        A.CDFILIAL||A.NRLANCESTQ||TP.CDEXTIPOOPER,
                        TP.CDEXTIPOOPER,
                        FR.CDEMPRESA,
                        '',
                        '',
                        '',
                        '',
                        NULL,
                        A.DTLANCESTQ,
                        NULL,
                        '',
                        A.CDFILIMOVI,
                        '',
                        'S',
                        CDALMOXENTR,
                        E.CDPAIS,
                        '',
                        '',
                        '',
                        '',
                        '')
   LOOP
      /* Log igual a Inclusao (Ingresso) */
      V_LOG     := 'I';
      V_IMPORTA := '';
      V_LINEA   := '';

      /* Se o pas for diferente de Colmbia (0057) e o fornecedor for diferente de I00000000008909298771 */
      IF (C_ENTRADA.CDPAIS||C_ENTRADA.RUT <> '005700000000008909298771') THEN
         IF (C_ENTRADA.CDTIPOOPER IN ('08','20')) THEN
            /* Se o tipo de operao da nf for 08 ou 20 s ser exportado para o pas Chile (0056) */
            IF (C_ENTRADA.CDPAIS = '0056') THEN
               V_IMPORTA := 'S';
            ELSE
               V_IMPORTA := 'N';
            END IF;
         ELSE
            V_IMPORTA := 'S';
         END IF;
      ELSE
         V_IMPORTA := 'N';
      END IF;

      IF (V_IMPORTA = 'S') THEN

         /* Verifica centro e centro_destino (Entidade) */
         IF (NOT C_ENTRADA.CDALMOXARIFE IS NULL) THEN
            /* Se o tipo de operao da nota fiscal atualiza estoque */
            IF C_ENTRADA.IDATUESTTPOP = 'S' THEN
               BEGIN
                  SELECT U.DSENTIDADE
                  INTO V_CENTRO
                  FROM USR_ENTSOLOMON U
                  WHERE
                     (U.CDPAISENT   = C_ENTRADA.CDPAIS)        AND
                     (U.TPMOVIENT   = 'O')                     AND
                     (U.CDFILIALENT = C_ENTRADA.CDFILIRECE)    AND
                     (U.CDBODERATIV = C_ENTRADA.CDALMOXARIFE);
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_CENTRO := NULL;
               END;

               BEGIN
                  SELECT U.DSENTIDADE
                  INTO V_CENTRODEST
                  FROM USR_ENTSOLOMON U
                  WHERE
                     (U.CDPAISENT   = C_ENTRADA.CDPAISDEST)    AND
                     (U.TPMOVIENT   = 'O')                     AND
                     (U.CDFILIALENT = C_ENTRADA.CDFILIEMIT)    AND
                     (U.CDBODERATIV = C_ENTRADA.CDALMOXARIFE);
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_CENTRODEST := NULL;
               END;
            ELSE
               BEGIN
                  SELECT U.DSENTIDADE
                  INTO V_CENTRO
                  FROM USR_ENTSOLOMON U
                  WHERE
                     (U.CDPAISENT   = C_ENTRADA.CDPAIS)        AND
                     (U.TPMOVIENT   = 'O')                     AND
                     (U.CDFILIALENT = C_ENTRADA.CDFILIRECE)    AND
                     (U.CDBODERATIV = C_ENTRADA.CDFILIRECE);
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_CENTRO := NULL;
               END;

               BEGIN
                  SELECT U.DSENTIDADE
                  INTO V_CENTRODEST
                  FROM USR_ENTSOLOMON U
                  WHERE
                     (U.CDPAISENT   = C_ENTRADA.CDPAISDEST)    AND
                     (U.TPMOVIENT   = 'O')                     AND
                     (U.CDFILIALENT = C_ENTRADA.CDFILIEMIT)    AND
                     (U.CDBODERATIV = C_ENTRADA.CDFILIEMIT);
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_CENTRODEST := NULL;
               END;
            END IF;
         ELSE
            BEGIN
               SELECT U.DSENTIDADE
               INTO V_CENTRO
               FROM USR_ENTSOLOMON U
               WHERE
                  (U.CDPAISENT   = C_ENTRADA.CDPAIS)        AND
                  (U.TPMOVIENT   = 'O')                     AND
                  (U.CDFILIALENT = C_ENTRADA.CDFILIRECE)    AND
                  (U.CDBODERATIV = C_ENTRADA.CDFILIRECE);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CENTRO := NULL;
            END;

            BEGIN
               SELECT U.DSENTIDADE
               INTO V_CENTRODEST
               FROM USR_ENTSOLOMON U
               WHERE
                  (U.CDPAISENT   = C_ENTRADA.CDPAISDEST)  AND
                  (U.TPMOVIENT   = 'O')                   AND
                  (U.CDFILIALENT = C_ENTRADA.CDFILIEMIT)  AND
                  (U.CDBODERATIV = C_ENTRADA.CDFILIEMIT);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CENTRODEST := NULL;
            END;
         END IF;

         UPDATE NF_CABECERA_INTG
         SET LOG_ID = V_LOG
         WHERE
            (ID = C_ENTRADA.ID);

         IF SQL%ROWCOUNT = 0 THEN
            /* Log igual a incluso (Ingresso) */
            V_LOG := 'I';

            INSERT INTO NF_CABECERA_INTG
               (ID, TIPO_OPERACION, CENTRO, EMPRESA, CENTRO_DESTINO, SERIE,
                COD_CLI_FORN, DIRECCION, COMUNA, GIRO, CUENTA_CONTABLE, DOCUMENTO_NUMERO, DOCUMENTO_FECHA,
                DOCUMENTO_FECHA_ENTRADA, DOCUMENTO_FECHA_VENCIMIENTO, DOCUMENTO_TOTAL, LOG_ID, FECHA_EXPORTAC)
            VALUES
               (C_ENTRADA.ID, C_ENTRADA.CDEXTIPOOPER, V_CENTRO, C_ENTRADA.EMPRESA, V_CENTRODEST,
                C_ENTRADA.CDSERIEENTR, C_ENTRADA.RUT, C_ENTRADA.CDMUNICIPIO, C_ENTRADA.NRCEPFORN, C_ENTRADA.NRCEPFORN,
                C_ENTRADA.CUENTA_CONTABLE, C_ENTRADA.NRNOTAFISC, C_ENTRADA.DTEMISSAO,
                C_ENTRADA.DTENTRSAID, C_ENTRADA.DATAVENC, SUBSTR(TO_CHAR(ROUND(C_ENTRADA.VRNOTAFISC,2)),1,20), V_LOG, SYSDATE);
         ELSE
            /* Log igual a Alterao (Cambio) */
            V_LOG := 'C';

            UPDATE NF_CABECERA_INTG
            SET TIPO_OPERACION              = C_ENTRADA.CDEXTIPOOPER,
                CENTRO                      = V_CENTRO,
                EMPRESA                     = C_ENTRADA.EMPRESA,
                CENTRO_DESTINO              = V_CENTRODEST,
                SERIE                       = C_ENTRADA.CDSERIEENTR,
                COD_CLI_FORN                = C_ENTRADA.RUT,
                DIRECCION                   = C_ENTRADA.CDMUNICIPIO,
                COMUNA                      = C_ENTRADA.NRCEPFORN,
                GIRO                        = C_ENTRADA.NRCEPFORN,
                CUENTA_CONTABLE             = C_ENTRADA.CUENTA_CONTABLE,
                DOCUMENTO_NUMERO            = C_ENTRADA.NRNOTAFISC,
                DOCUMENTO_FECHA             = C_ENTRADA.DTEMISSAO,
                DOCUMENTO_FECHA_ENTRADA     = C_ENTRADA.DTENTRSAID,
                DOCUMENTO_FECHA_VENCIMIENTO = C_ENTRADA.DATAVENC,
                DOCUMENTO_TOTAL             = SUBSTR(TO_CHAR(C_ENTRADA.VRNOTAFISC),1,20),
                LOG_ID                      = V_LOG,
                FECHA_EXPORTAC				  = SYSDATE
            WHERE
               (ID = C_ENTRADA.ID);
         END IF;

         /*Remove itens referentes a nota*/
         DELETE
           FROM NF_DETALLE_INTG
          WHERE
              ID = C_ENTRADA.ID;
         FOR C_ITEMENTRADA IN (SELECT
                                  C_ENTRADA.ID,
                                  N.IDTEKNISA,
                                  N.CDCONTCTBL,
                                  V_CENTRO AS CENTRO,
                                  N.PRODUTO,
                                  N.NMPRODUTO,
                                  N.MONTO,
                                  N.IMPUESTO,
                                  N.MONTO_IMP,
                                  N.QTDEPROD,
                                  N.VRUNIT,
                                  N.BODEGA,
                                  C_ENTRADA.CDFILIRECE,
                                  N.IDALMOXARIFE
                               FROM
                                  (SELECT
                                      A.IDTEKNISA,
                                      A.CDCONTCTBL,
                                      A.PRODUTO,
                                      A.NMPRODUTO,
                                      A.MONTO,
                                      A.IMPUESTO,
                                      A.MONTO_IMP,
                                      A.QTDEPROD,
                                      A.VRUNIT,
                                      A.BODEGA,
                                      A.IDALMOXARIFE
                                   FROM
                                      (SELECT
                                          IT.CDFILIAL||IT.NRLANCTONF||IT.NRSEQITPROD AS IDTEKNISA,
                                          USR_CONTCTBL_PROD(IT.CDFILIAL, IT.NRLANCTONF, IT.CDPRODUTO, PD.CDARVPROD) AS CDCONTCTBL,
                                          PD.CDARVPROD AS PRODUTO,
                                          PD.NMPRODUTO AS NMPRODUTO,
                                          IT.VRTOTAITEM AS MONTO,
                                          0 AS IMPUESTO,
                                          0 AS MONTO_IMP,
                                          IT.QTITEMPROD AS QTDEPROD,
                                          IT.VRUNITITEM AS VRUNIT,
                                          LPAD(IT.CDALMOXARIFE,4,' ') AS BODEGA,
                                          C_ENTRADA.IDALMOXARIFE AS IDALMOXARIFE
                                       FROM ITEMPRODUTO IT, PRODUTO PD
                                       WHERE
                                          (IT.CDFILIAL   = C_ENTRADA.CDFILIAL)    AND
                                          (IT.NRLANCTONF = C_ENTRADA.NRLANCTONF)  AND
                                          (C_ENTRADA.NRLANCESTQ IS NULL)          AND
                                          (IT.CDPRODUTO  = PD.CDPRODUTO)
                                       UNION ALL
                                       SELECT
                                          IT.CDFILIAL||IT.NRLANCTONF||IT.NRSEQITPROD||IT.CDIMPOSTO||IT.NRITPROIMPOS AS IDTEKNISA,
                                          USR_CONTCTBL_IMPOSTO(IT.CDFILIAL, IT.NRLANCTONF, IT.CDIMPOSTO) AS CDCONTCTBL,
                                          IT.CDIMPOSTO AS PRODUTO,
                                          '' AS NMPRODUTO,
                                          IT.VRBASECALCIT AS MONTO,
                                          IT.VRALIQITEM AS IMPUESTO,
                                          IT.VRIMPOSTOIT AS MONTO_IMP,
                                          0 AS QTDEPROD,
                                          0 AS VRUNIT,
                                          LPAD(' ',4,' ') AS BODEGA,
                                          '' AS IDALMOXARIFE
                                       FROM ITEMPROIMPOS IT
                                       WHERE
                                          (IT.CDFILIAL    = C_ENTRADA.CDFILIAL)     AND
                                          (IT.NRLANCTONF  = C_ENTRADA.NRLANCTONF)   AND
                                          (IT.VRIMPOSTOIT <> 0)
                                      ) A
                                   ORDER BY A.IDTEKNISA) N
                               UNION ALL
                               SELECT
                                  C_ENTRADA.ID,
                                  IT.CDFILIAL||IT.NRLANCESTQ||IT.NRSEQUITEM AS IDTEKNISA,
                                  USR_CONTCTBL_PROD(IT.CDFILIAL, ' ', IT.CDPRODUTO, PD.CDARVPROD) AS CDCONTCTBL,
                                  V_CENTRO AS CENTRO,
                                  PD.CDARVPROD AS PRODUTO,
                                  PD.NMPRODUTO AS NMPRODUTO,
                                  IT.VRTOTLANCTO AS MONTO,
                                  0 AS IMPUESTO,
                                  0 AS MONTO_IMP,
                                  IT.QTLANCTOEST AS QTDEPROD,
                                  IT.VRUNILANCTO AS VRUNIT,
                                  LPAD(IT.CDALMOXARIFE,4,' ') AS BODEGA,
                                  C_ENTRADA.CDFILIRECE,
                                  '' AS IDALMOXARIFE
                               FROM ITLANCTOEST IT, PRODUTO PD
                               WHERE
                                  (IT.CDFILIAL   = C_ENTRADA.CDFILIAL)    AND
                                  (IT.NRLANCESTQ = C_ENTRADA.NRLANCESTQ)  AND
                                  (IT.CDPRODUTO  = PD.CDPRODUTO)
                               UNION ALL
                               SELECT
                                  C_ENTRADA.ID,
                                  IT.CDFILIAL||IT.NRLANCTONF||IT.CDIMPOSTO||IT.NRIMPOSNF AS IDTEKNISA,
                                  USR_CONTCTBL_IMPOSTO(IT.CDFILIAL, IT.NRLANCTONF, IT.CDIMPOSTO) AS CDCONTCTBL,
                                  V_CENTRO AS CENTRO,
                                  IT.CDIMPOSTO AS PRODUTO,
                                  '' AS NMPRODUTO,
                                  IT.VRBASECALCNF AS MONTO,
                                  IT.VRALIQNF AS IMPUESTO,
                                  IT.VRIMPOSTONF AS MONTO_IMP,
                                  0 AS QTDEPROD,
                                  0 AS VRUNIT,
                                  LPAD(' ',4,' ') AS BODEGA,
                                  C_ENTRADA.CDFILIRECE,
                                  '' AS IDALMOXARIFE
                               FROM IMPOSTONF IT, IMPOSTO I
                               WHERE
                                  (IT.CDFILIAL    = C_ENTRADA.CDFILIAL)     AND
                                  (IT.NRLANCTONF  = C_ENTRADA.NRLANCTONF)   AND
                                  (IT.VRIMPOSTONF <> 0)                     AND
                                  (I.CDIMPOSTO    = IT.CDIMPOSTO)           AND
                                  (I.IDPRODNOTA   = 'C')
                               UNION ALL
                               SELECT
                                  C_ENTRADA.ID,
                                  IT.CDFILIAL||IT.NRLANCTONF||IT.CDENCARGO AS IDTEKNISA,
                                  USR_CONTCTBL_ENCARGO(IT.CDFILIAL, IT.NRLANCTONF, IT.CDENCARGO) AS CDCONTCTBL,
                                  V_CENTRO AS CENTRO,
                                  '' AS PRODUTO,
                                  '' AS NMPRODUTO,
                                  IT.VRITEMENCA AS MONTO,
                                  0 AS IMPUESTO,
                                  0 AS MONTO_IMP,
                                  0 AS QTDEPROD,
                                  0 AS VRUNIT,
                                  LPAD(' ',4,' ') AS BODEGA,
                                  C_ENTRADA.CDFILIRECE,
                                  '' AS IDALMOXARIFE
                               FROM ITEMENCARGO IT
                               WHERE
                                  (IT.CDFILIAL      = C_ENTRADA.CDFILIAL)    AND
                                  (IT.NRLANCTONF    = C_ENTRADA.NRLANCTONF)  AND
                                  (IT.CDENCARGO     in ('01','02'))                  AND
                                  (IT.VRITEMENCA   <> 0)                     AND
                                  (C_ENTRADA.CDPAIS = '0056')
                              )
         LOOP

            IF C_ITEMENTRADA.IDALMOXARIFE = 'S' THEN
               V_BODEGA := C_ITEMENTRADA.BODEGA;
            ELSE
               V_BODEGA := C_ITEMENTRADA.CDFILIRECE;
            END IF;

           /* Verifica sequencial (LINEA) para inserir na tabela NF_DETALLE_INTG */
           SELECT NVL(LPAD(TO_CHAR(TO_NUMBER(MAX(LINEA)) + 1),4,'0'),'0001')
             INTO V_LINEA
             FROM NF_DETALLE_INTG
            WHERE
               (ID = C_ITEMENTRADA.ID);

           INSERT INTO NF_DETALLE_INTG
               (ID, IDTEKNISA, LINEA, CUENTA, CENTRO, PRODUCTO, DESCRIPCION_CODIGO_ARBOL,
                MONTO, IMPUESTO, MONTO_IMP, CANTIDAD, VALOR_UNITARIO, BODEGA, FECHA_EXPORTAC)
           VALUES
               (C_ITEMENTRADA.ID, C_ITEMENTRADA.IDTEKNISA, V_LINEA,
                C_ITEMENTRADA.CDCONTCTBL, C_ITEMENTRADA.CENTRO, SUBSTR(C_ITEMENTRADA.PRODUTO,1,10),
                C_ITEMENTRADA.NMPRODUTO, SUBSTR(TO_CHAR(ROUND(C_ITEMENTRADA.MONTO,2)),1,20),
                SUBSTR(TO_CHAR(ROUND(C_ITEMENTRADA.IMPUESTO,2)),1,20), SUBSTR(TO_CHAR(ROUND(C_ITEMENTRADA.MONTO_IMP,2)),1,20),
                SUBSTR(TO_CHAR(ROUND(C_ITEMENTRADA.QTDEPROD,2)),1,20), SUBSTR(TO_CHAR(ROUND(C_ITEMENTRADA.VRUNIT,2)),1,20),
                V_BODEGA, SYSDATE);
         END LOOP;
         V_TOTAITENS := 0;
         SELECT COUNT(*)
           INTO V_TOTAITENS
           FROM NF_DETALLE_INTG
          WHERE ID = C_ENTRADA.ID;

         IF V_TOTAITENS <= 0 THEN
            DELETE FROM NF_CABECERA_INTG
             WHERE ID = C_ENTRADA.ID;
         END IF;
      END IF;
   END LOOP;

   /* Verificao dos documentos de Sada */
   FOR C_SAIDA IN (SELECT
                      N.CDFILIAL,
                      N.NRLANCTONF,
                      '' AS NRLANCESTQ,
                      N.CDFILIAL||N.NRLANCTONF||TP.CDEXTIPOOPER AS ID,
                      TP.CDEXTIPOOPER,
                      N.CDEMPRESA AS EMPRESA,
                      N.CDSERIE,
                      SUBSTR(N.NRINSJURNF,1,20) AS RUT,
                      DECODE(N.IDSISTEMA, 'FAI',CL.NMRAZSOCCLIE, '') AS NMRAZSOCCLIE,
                      DECODE(N.IDSISTEMA, 'FAI',CL.NMFANTCLIE, '') AS NMFANTCLIE,
                      DECODE(N.IDSISTEMA, 'FAI',EC.DSENDECLIE, '') AS DSENDECLIE,
                      DECODE(N.IDSISTEMA, 'FAI',EC.CDMUNICIPIO, '') AS CDMUNICIPIO,
                      DECODE(N.IDSISTEMA, 'FAI',A.USR_DSGIRO, '') AS DSATIVCLI,
                      CT.CDCONTREDU AS CUENTA_CONTABLE,
                      DECODE(ED.CDPAIS, '0054', SUBSTR(N.CDSERIE,2,4)||LPAD(N.NRNOTAFISC, 8, '0'), N.NRNOTAFISC) AS NRNOTAFISC,
                      N.DTEMISSAO,
                      DECODE(AP.DTFIMAPURAC, NULL, N.DTFINREFEFAT, AP.DTFIMAPURAC) AS DTENTRSAID,
                      MIN(C.DTORIGVENREC) AS DATAVENC,
                      ROUND(N.VRNOTAFISC,2) AS VRNOTAFISC,
                      N.CDFILIEMIT,
                      N.CDFILIRECE,
                      ALMOX.IDALMOXARIFE,
                      ALMOX.CDALMOXARIFE,
                      E.CDPAIS,
                      ED.CDPAIS AS CDPAISDEST,
                      N.IDSISTEMA,
                      CL.USR_CDGIRO AS CDATIVCLI,
                      TP.IDATUESTTPOP
                   FROM
                      NOTAFISCAL N, CONTARECEBER C, TIPOOPERAC TP, CLIENTE CL, ENDECLIE EC, USR_GIRO A,
                      ENDEFILI E, ENDEFILI ED, CONTCTBL CT, CTRLAPURFAT AP,
                      (SELECT N.CDFILIAL, N.NRLANCTONF, 'S' AS IDALMOXARIFE, MAX(I.CDALMOXARIFE) AS CDALMOXARIFE
                       FROM NOTAFISCAL N, ITEMPRODUTO I
                       WHERE
                          (N.CDFILIEMIT   = P_CDFILIAL)                               AND
                          (N.IDENTRSAIDOP = 'S')                                      AND
                          (N.DTENTRSAID   = P_DTINICIAL)                              AND
                          (N.IDSTATUS in ('E','A'))                                   AND
                          (N.CDTIPOOPER    NOT IN  ('09','10'))                       AND
                          (N.IDSISTEMA IN ('DFS','EST','FAI') OR N.IDSISTEMA IS NULL) AND
                          (I.CDFILIAL     = N.CDFILIAL)                               AND
                          (I.NRLANCTONF   = N.NRLANCTONF)                             AND
                          (I.CDALMOXARIFE <> ' ')
                       GROUP BY
                          N.CDFILIAL, N.NRLANCTONF, 'S'
                      ) ALMOX
                   WHERE
                      (N.CDFILIEMIT        = P_CDFILIAL)                          AND
                      (N.IDENTRSAIDOP      = 'S')                                 AND
                      (N.DTENTRSAID        = P_DTINICIAL)                         AND
                      (N.IDSTATUS in ('E','A'))                                   AND
                      (N.CDTIPOOPER    NOT IN  ('09','10'))                       AND
                      (N.IDSISTEMA IN ('DFS','EST','FAI') OR N.IDSISTEMA IS NULL) AND
                      (N.CDFILIAL          = C.CDFILIAL(+))                       AND
                      (N.NRLANCTONF        = C.NRLANCTONF(+))                     AND
                      NOT EXISTS (SELECT CDFILIAL FROM LANCTOESTOQ L
                                  WHERE (L.CDFILIAL   = N.CDFILIAL)    AND
                                        (L.NRLANCTONF = N.NRLANCTONF)  AND
                                        (L.IDTPLANCTO  IN ('3','4')))             AND
                      (N.CDFILIAL          = ALMOX.CDFILIAL (+))                  AND
                      (N.NRLANCTONF        = ALMOX.NRLANCTONF (+))                AND
                      (TP.IDENTRSAIDOP     = N.IDENTRSAIDOP)                      AND
                      (TP.CDTIPOOPER       = N.CDTIPOOPER)                        AND
                      (CL.CDCLIENTE (+)    = N.CDCLIENTE)                         AND
                      (CL.CDCONTCTBL       = CT.CDCONTCTBL (+))                   AND
                      (E.CDFILIAL (+)      = N.CDFILIRECE)                        AND
                      (E.IDTPENDEFILI (+)  = 'P')                                 AND
                      (ED.CDFILIAL (+)     = N.CDFILIEMIT)                        AND
                      (ED.IDTPENDEFILI (+) = 'P')                                 AND
                      (EC.CDCLIENTE   (+)  = N.CDCLIENTE)                         AND
                      (EC.IDTPENDECLIE (+) = 'P')                                 AND
                      (A.USR_CDGIRO  (+)   = CL.USR_CDGIRO)                       AND
                      (AP.CDFILIAL (+)     = N.CDFILIAL)                          AND
                      (AP.NRAPURACFAT (+)  = N.NRAPURACFAT)
                   GROUP BY
                      N.CDFILIAL,
                      N.NRLANCTONF,
                      '',
                      N.CDFILIAL||N.NRLANCTONF||TP.CDEXTIPOOPER,
                      TP.CDEXTIPOOPER,
                      N.CDEMPRESA,
                      N.CDSERIE,
                      SUBSTR(N.NRINSJURNF,1,20),
                      DECODE(N.IDSISTEMA, 'FAI',CL.NMRAZSOCCLIE, ''),
                      DECODE(N.IDSISTEMA, 'FAI',CL.NMFANTCLIE, ''),
                      DECODE(N.IDSISTEMA, 'FAI',EC.DSENDECLIE, ''),
                      DECODE(N.IDSISTEMA, 'FAI',EC.CDMUNICIPIO, ''),
                      DECODE(N.IDSISTEMA, 'FAI',A.USR_DSGIRO, ''),
                      CT.CDCONTREDU,
                      DECODE(ED.CDPAIS, '0054', SUBSTR(N.CDSERIE,2,4)||LPAD(N.NRNOTAFISC, 8, '0'), N.NRNOTAFISC),
                      N.DTEMISSAO,
                      DECODE(AP.DTFIMAPURAC, NULL, N.DTFINREFEFAT, AP.DTFIMAPURAC),
                      ROUND(N.VRNOTAFISC,2),
                      N.CDFILIEMIT,
                      N.CDFILIRECE,
                      ALMOX.IDALMOXARIFE,
                      ALMOX.CDALMOXARIFE,
                      E.CDPAIS,
                      ED.CDPAIS,
                      N.IDSISTEMA,
                      CL.USR_CDGIRO,
                      TP.IDATUESTTPOP

                   UNION ALL

                   /* Saidas de estoque (lanadas pelo sistemas EST) e Retiradas de estoque */
                   SELECT
                      A.CDFILIAL,
                      A.NRLANCTONF,
                      A.NRLANCESTQ,
                      A.CDFILIAL||A.NRLANCESTQ||DECODE(A.IDTPLANCTO, '3', TR.CDEXTIPOOPER, TT.CDEXTIPOOPER) AS ID,
                      DECODE(A.IDTPLANCTO, '3', TR.CDEXTIPOOPER, TT.CDEXTIPOOPER) AS CDEXTIPOOPER,
                      FR.CDEMPRESA AS EMPRESA,
                      '' AS CDSERIE,
                      '' AS RUT,
                      '' AS NMRAZSOCCLIE,
                      '' AS NMFANTCLIE,
                      '' AS DSENDECLIE,
                      '' AS CDMUNICIPIO,
                      '' AS DSATIVCLI,
                      '' AS CUENTA_CONTABLE,
                      '' AS NRNOTAFISC,
                      NULL  AS DTEMISSAO,
                      A.DTLANCESTQ AS DTENTRSAID,
                      NULL  AS DATAVENC,
                      ROUND(SUM(I.VRTOTLANCTO),2) AS VRNOTAFISC,
                      A.CDFILIMOVI AS CDFILIEMIT,
                      '' AS CDFILIRECE,
                      '' AS IDALMOXARIFE,
                      C.CDALMOXSAID AS CDALMOXARIFE,
                      E.CDPAIS,
                      '' AS CDPAISDEST,
                      '' AS IDSISTEMA,
                      '' AS CDATIVCLI,
                      '' AS IDATUESTTPOP
                   FROM
                      LANCTOESTOQ A, FILIAL F, ITLANCTOEST I, TIPOOPERAC TR,
                      TIPOOPERAC TT, FILIAL FR, ENDEFILI E, CTRLMOVIESTQ C
                   WHERE
                      (A.CDFILIMOVI      = P_CDFILIAL)             AND
                      (A.IDTPLANCTO  IN ('3','4'))                 AND
                      (A.DTLANCESTQ       = P_DTINICIAL)           AND
                      (A.CDFILIAL         = F.CDFILIAL)            AND
                      (A.CDFILIAL         = I.CDFILIAL)            AND
                      (A.NRLANCESTQ       = I.NRLANCESTQ)          AND
                      (TR.IDENTRSAIDOP    = 'S')                   AND
                      (TR.CDTIPOOPER      = '85')                  AND
                      (TT.IDENTRSAIDOP    = 'S')                   AND
                      (TT.CDTIPOOPER      = '95')                  AND
                      (E.CDFILIAL         = A.CDFILIMOVI)          AND
                      (E.IDTPENDEFILI     = 'P')                   AND
                      (C.CDFILIALSAID (+) = A.CDFILIAL)            AND
                      (C.NRLANESTSAID (+) = A.NRLANCESTQ)
                   GROUP BY
                      A.CDFILIAL,
                      A.NRLANCTONF,
                      A.NRLANCESTQ,
                      A.CDFILIAL||A.NRLANCESTQ||DECODE(A.IDTPLANCTO, '3', TR.CDEXTIPOOPER, TT.CDEXTIPOOPER),
                      DECODE(A.IDTPLANCTO, '3', TR.CDEXTIPOOPER, TT.CDEXTIPOOPER),
                      FR.CDEMPRESA,
                      '',
                      '',
                      '',
                      '',
                      '',
                      '',
                      '',
                      '',
                      '',
                      NULL,
                      A.DTLANCESTQ,
                      NULL,
                      A.CDFILIMOVI,
                      '',
                      '',
                      C.CDALMOXSAID,
                      E.CDPAIS,
                      '',
                      '',
                      '',
                      ''

                   UNION ALL

                   /* Posio de estoque */
                   SELECT
                      P.CDFILIAL,
                      '' AS NRLANCTONF,
                      '' AS NRLANCESTQ,
                      (P.CDFILIAL||TO_CHAR(P_DTINICIAL, 'DDMMYYYY')||TP.CDEXTIPOOPER) AS ID,
                      TP.CDEXTIPOOPER,
                      F.CDEMPRESA AS EMPRESA,
                      '' AS CDSERIE,
                      '' AS RUT,
                      '' AS NMRAZSOCCLIE,
                      '' AS NMFANTCLIE,
                      '' AS DSENDECLIE,
                      '' AS CDMUNICIPIO,
                      '' AS DSATIVCLI,
                      '' AS CUENTA_CONTABLE,
                      '' AS NRNOTAFISC,
                      NULL  AS DTEMISSAO,
                      NULL  AS DTENTRSAID,
                      NULL  AS DATAVENC,
                      ROUND(SUM(P.VRESTOQDIA),2) AS VRNOTAFISC,
                      P.CDFILIAL AS CDFILIEMIT,
                      '' AS CDFILIRECE,
                      '' AS IDALMOXARIFE,
                      '' AS CDALMOXARIFE,
                      '' AS CDPAIS,
                      '' AS CDPAISDEST,
                      '' AS IDSISTEMA,
                      '' AS CDATIVCLI,
                      '' AS IDATUESTTPOP
                   FROM POSESTDIA P, PRODUTO PROD, FILIAL F, TIPOOPERAC TP, ALMOXARIFADO A
                   WHERE
                      (P.CDFILIAL      = P_CDFILIAL)                                      AND
                      (P.CDFILIAL      = A.CDFILIAL)                                      AND
                      (P.CDALMOXARIFE  = A.CDALMOXARIFE)                                  AND
                      (P.NRLOTEESTQ    = ' ')                                             AND
                      (P.NRSUBLOTE     = ' ')                                             AND
                      (P.CDPRODUTO     = PROD.CDPRODUTO)                                  AND
                      (P.QTESTOQDIA <> 0)                                                 AND
                      (P.DTPOSIESTQ = (SELECT MAX(C.DTPOSIESTQ)
                                       FROM POSESTDIA C
                                       WHERE (C.CDFILIAL     = P.CDFILIAL)      AND
                                             (C.CDPRODUTO    = P.CDPRODUTO)     AND
                                             (C.CDALMOXARIFE = P.CDALMOXARIFE)  AND
                                             (C.CDLOCALESTOQ = P.CDLOCALESTOQ)  AND
                                             (C.NRLOTEESTQ   = P.NRLOTEESTQ)    AND
                                             (C.NRSUBLOTE    = P.NRSUBLOTE)     AND
                                             (C.DTPOSIESTQ <= TO_DATE(P_DTINICIAL + 1)))) AND
                      (F.CDFILIAL      = P.CDFILIAL)                                      AND
                      (TP.IDENTRSAIDOP = 'S')                                             AND
                      (TP.CDTIPOOPER   = '80')
                   GROUP BY
                      P.CDFILIAL,
                      '',
                      '',
                      (P.CDFILIAL||TO_CHAR(P_DTINICIAL, 'DDMMYYYY')||TP.CDEXTIPOOPER),
                      TP.CDEXTIPOOPER,
                      F.CDEMPRESA,
                      '',
                      '',
                      '',
                      '',
                      '',
                      '',
                      '',
                      '',
                      '',
                      NULL,
                      NULL,
                      NULL,
                      P.CDFILIAL,
                      '',
                      '',
                      '',
                      '',
                      '',
                      '',
                      '',
                      '')
   LOOP
      /* Log igual a Inclusao (Ingresso) */
      V_LOG   := 'I';
      V_LINEA := '';

      /* Verifica centro e centro_destino (Entidade) para notas fiscais de Faturamento */
      IF ((C_SAIDA.IDSISTEMA = 'FAI') AND ((C_SAIDA.CDPAIS = '0057') OR (C_SAIDA.CDPAISDEST = '0057'))) THEN
         BEGIN
            SELECT U.DSENTIDADE
            INTO V_CENTRODEST
            FROM USR_ENTSOLOMON U
            WHERE
               (U.CDPAISENT   = C_SAIDA.CDPAIS)        AND
               (U.TPMOVIENT   = 'F')                   AND
               (U.CDFILIALENT = C_SAIDA.CDFILIRECE)    AND
               (U.CDBODERATIV = C_SAIDA.CDATIVCLI);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CENTRODEST := NULL;
         END;

         BEGIN
            SELECT U.DSENTIDADE
            INTO V_CENTRO
            FROM USR_ENTSOLOMON U
            WHERE
               (U.CDPAISENT   = C_SAIDA.CDPAISDEST)    AND
               (U.TPMOVIENT   = 'F')                   AND
               (U.CDFILIALENT = C_SAIDA.CDFILIEMIT)    AND
               (U.CDBODERATIV = C_SAIDA.CDATIVCLI);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CENTRO := NULL;
         END;
      ELSE
         IF (C_SAIDA.IDSISTEMA <> 'FAI') THEN

            /* Verifica centro e centro_destino (Entidade) */
            IF (NOT C_SAIDA.CDALMOXARIFE IS NULL) THEN
               /* Se o tipo de operao da nota fiscal atualiza estoque */
               IF C_SAIDA.IDATUESTTPOP = 'S' THEN
                  BEGIN
                     SELECT U.DSENTIDADE
                     INTO V_CENTRODEST
                     FROM USR_ENTSOLOMON U
                     WHERE
                        (U.CDPAISENT   = C_SAIDA.CDPAIS)        AND
                        (U.TPMOVIENT   = 'O')                   AND
                        (U.CDFILIALENT = C_SAIDA.CDFILIRECE)    AND
                        (U.CDBODERATIV = C_SAIDA.CDALMOXARIFE);
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CENTRODEST := NULL;
                  END;

                  BEGIN
                     SELECT U.DSENTIDADE
                     INTO V_CENTRO
                     FROM USR_ENTSOLOMON U
                     WHERE
                        (U.CDPAISENT   = C_SAIDA.CDPAISDEST)    AND
                        (U.TPMOVIENT   = 'O')                   AND
                        (U.CDFILIALENT = C_SAIDA.CDFILIEMIT)    AND
                        (U.CDBODERATIV = C_SAIDA.CDALMOXARIFE);
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CENTRO := NULL;
                  END;
               ELSE
                  BEGIN
                     SELECT U.DSENTIDADE
                     INTO V_CENTRODEST
                     FROM USR_ENTSOLOMON U
                     WHERE
                        (U.CDPAISENT   = C_SAIDA.CDPAIS)        AND
                        (U.TPMOVIENT   = 'O')                   AND
                        (U.CDFILIALENT = C_SAIDA.CDFILIRECE)    AND
                        (U.CDBODERATIV = C_SAIDA.CDFILIRECE);
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CENTRODEST := NULL;
                  END;

                  BEGIN
                     SELECT U.DSENTIDADE
                     INTO V_CENTRO
                     FROM USR_ENTSOLOMON U
                     WHERE
                        (U.CDPAISENT   = C_SAIDA.CDPAISDEST)    AND
                        (U.TPMOVIENT   = 'O')                   AND
                        (U.CDFILIALENT = C_SAIDA.CDFILIEMIT)    AND
                        (U.CDBODERATIV = C_SAIDA.CDFILIEMIT);
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CENTRO := NULL;
                  END;
               END IF;
            ELSE
               BEGIN
                  SELECT U.DSENTIDADE
                  INTO V_CENTRODEST
                  FROM USR_ENTSOLOMON U
                  WHERE
                     (U.CDPAISENT   = C_SAIDA.CDPAIS)        AND
                     (U.TPMOVIENT   = 'O')                   AND
                     (U.CDFILIALENT = C_SAIDA.CDFILIRECE)    AND
                     (U.CDBODERATIV = C_SAIDA.CDFILIRECE);
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_CENTRODEST := NULL;
               END;

               BEGIN
                  SELECT U.DSENTIDADE
                  INTO V_CENTRO
                  FROM USR_ENTSOLOMON U
                  WHERE
                     (U.CDPAISENT   = C_SAIDA.CDPAISDEST)  AND
                     (U.TPMOVIENT   = 'O')                 AND
                     (U.CDFILIALENT = C_SAIDA.CDFILIEMIT)  AND
                     (U.CDBODERATIV = C_SAIDA.CDFILIEMIT);
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_CENTRO := NULL;
               END;
            END IF;
         ELSE
            /* Faturamento - Pas Argentina e filial 8006 ser retornado o contudo das mensagens adicionais */
            IF ((C_SAIDA.CDPAIS = '0054')     OR (C_SAIDA.CDPAISDEST = '0054')) AND
               ((C_SAIDA.CDFILIRECE = '8006') OR (C_SAIDA.CDFILIEMIT = '8006') OR
                (C_SAIDA.CDFILIRECE = '8007') OR (C_SAIDA.CDFILIEMIT = '8007')) THEN
               BEGIN
                  SELECT USR_DADOS_ADIC(C_SAIDA.CDFILIAL, C_SAIDA.NRLANCTONF)
                  INTO V_CENTRO
                  FROM DUAL;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_CENTRO := NULL;
               END;
            ELSE
               BEGIN
                  SELECT U.DSENTIDADE
                  INTO V_CENTRODEST
                  FROM USR_ENTSOLOMON U
                  WHERE
                     (U.CDPAISENT   = C_SAIDA.CDPAIS)      AND
                     (U.TPMOVIENT   = 'F')                 AND
                     (U.CDFILIALENT = C_SAIDA.CDFILIRECE)  AND
                     (U.CDBODERATIV = C_SAIDA.CDFILIRECE);
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_CENTRODEST := NULL;
               END;

               BEGIN
                  SELECT U.DSENTIDADE
                  INTO V_CENTRO
                  FROM USR_ENTSOLOMON U
                  WHERE
                     (U.CDPAISENT   = C_SAIDA.CDPAISDEST)  AND
                     (U.TPMOVIENT   = 'F')                 AND
                     (U.CDFILIALENT = C_SAIDA.CDFILIEMIT)  AND
                     (U.CDBODERATIV = C_SAIDA.CDFILIEMIT);
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_CENTRO := NULL;
               END;
            END IF;
         END IF;
      END IF;

      UPDATE NF_CABECERA_INTG
      SET LOG_ID = V_LOG
      WHERE
         (ID = C_SAIDA.ID);

      IF SQL%ROWCOUNT = 0 THEN
         /* Log igual a incluso (Ingresso) */
         V_LOG := 'I';

         INSERT INTO NF_CABECERA_INTG
            (ID, TIPO_OPERACION, CENTRO, EMPRESA, CENTRO_DESTINO, SERIE,
             COD_CLI_FORN, RAZON_SOCIAL, NOMBRE_FANTASIA, DIRECCION, COMUNA, GIRO,
             CUENTA_CONTABLE, DOCUMENTO_NUMERO, DOCUMENTO_FECHA,
             DOCUMENTO_FECHA_ENTRADA, DOCUMENTO_FECHA_VENCIMIENTO, DOCUMENTO_TOTAL, LOG_ID, FECHA_EXPORTAC)
         VALUES
            (C_SAIDA.ID, C_SAIDA.CDEXTIPOOPER, V_CENTRO, C_SAIDA.EMPRESA, V_CENTRODEST,
             C_SAIDA.CDSERIE, C_SAIDA.RUT, C_SAIDA.NMRAZSOCCLIE, C_SAIDA.NMFANTCLIE,
             C_SAIDA.DSENDECLIE, C_SAIDA.CDMUNICIPIO, C_SAIDA.DSATIVCLI,
             C_SAIDA.CUENTA_CONTABLE, C_SAIDA.NRNOTAFISC, C_SAIDA.DTEMISSAO,
             C_SAIDA.DTENTRSAID, C_SAIDA.DATAVENC, SUBSTR(TO_CHAR(ROUND(C_SAIDA.VRNOTAFISC,2)),1,20), V_LOG, SYSDATE);
      ELSE
         /* Log igual a Alterao (Cambio) */
         V_LOG := 'C';

         UPDATE NF_CABECERA_INTG
         SET ID                          = C_SAIDA.ID,
             TIPO_OPERACION              = C_SAIDA.CDEXTIPOOPER,
             CENTRO                      = V_CENTRO,
             EMPRESA                     = C_SAIDA.EMPRESA,
             CENTRO_DESTINO              = V_CENTRODEST,
             SERIE                       = C_SAIDA.CDSERIE,
             COD_CLI_FORN                = C_SAIDA.RUT,
             RAZON_SOCIAL                = C_SAIDA.NMRAZSOCCLIE,
             NOMBRE_FANTASIA             = C_SAIDA.NMFANTCLIE,
             DIRECCION                   = C_SAIDA.DSENDECLIE,
             COMUNA                      = C_SAIDA.CDMUNICIPIO,
             GIRO                        = C_SAIDA.DSATIVCLI,
             CUENTA_CONTABLE             = C_SAIDA.CUENTA_CONTABLE,
             DOCUMENTO_NUMERO            = C_SAIDA.NRNOTAFISC,
             DOCUMENTO_FECHA             = C_SAIDA.DTEMISSAO,
             DOCUMENTO_FECHA_ENTRADA     = C_SAIDA.DTENTRSAID,
             DOCUMENTO_FECHA_VENCIMIENTO = C_SAIDA.DATAVENC,
             DOCUMENTO_TOTAL             = SUBSTR(TO_CHAR(C_SAIDA.VRNOTAFISC),1,20),
             LOG_ID                      = V_LOG,
             FECHA_EXPORTAC				  = SYSDATE
         WHERE
            (ID     = C_SAIDA.ID);
      END IF;

      DELETE
        FROM NF_DETALLE_INTG
       WHERE
          ID = C_SAIDA.ID;
      FOR C_ITEMSAIDA IN (SELECT
                             C_SAIDA.ID,
                             N.IDTEKNISA,
                             N.CDCONTCTBL,
                             V_CENTRO AS CENTRO,
                             N.PRODUTO,
                             N.NMPRODUTO,
                             N.MONTO,
                             N.IMPUESTO,
                             N.MONTO_IMP,
                             N.QTDEPROD,
                             N.VRUNIT,
                             N.BODEGA,
                             C_SAIDA.CDFILIEMIT,
                             N.IDALMOXARIFE
                          FROM
                             (SELECT
                                 A.IDTEKNISA,
                                 A.CDCONTCTBL,
                                 A.PRODUTO,
                                 A.NMPRODUTO,
                                 A.MONTO,
                                 A.IMPUESTO,
                                 A.MONTO_IMP,
                                 A.QTDEPROD,
                                 A.VRUNIT,
                                 A.BODEGA,
                                 A.IDALMOXARIFE
                              FROM
                                 (SELECT
                                     IT.CDFILIAL||IT.NRLANCTONF||IT.NRSEQITPROD AS IDTEKNISA,
                                     USR_CONTCTBL_PROD(IT.CDFILIAL, IT.NRLANCTONF, IT.CDPRODUTO, PD.CDARVPROD) AS CDCONTCTBL,
                                     PD.CDARVPROD AS PRODUTO,
                                     PD.NMPRODUTO AS NMPRODUTO,
                                     IT.VRTOTAITEM AS MONTO,
                                     0 AS IMPUESTO,
                                     0 AS MONTO_IMP,
                                     IT.QTITEMPROD AS QTDEPROD,
                                     IT.VRUNITITEM AS VRUNIT,
                                     LPAD(IT.CDALMOXARIFE,4,' ') AS BODEGA,
                                     C_SAIDA.IDALMOXARIFE AS IDALMOXARIFE
                                  FROM ITEMPRODUTO IT, PRODUTO PD
                                  WHERE
                                     (IT.CDFILIAL   = C_SAIDA.CDFILIAL)    AND
                                     (IT.NRLANCTONF = C_SAIDA.NRLANCTONF)  AND
                                     (C_SAIDA.NRLANCESTQ IS NULL)          AND
                                     (IT.CDPRODUTO  = PD.CDPRODUTO)
                                  UNION ALL
                                  SELECT
                                     IT.CDFILIAL||IT.NRLANCTONF||IT.NRSEQITPROD||IT.CDIMPOSTO||IT.NRITPROIMPOS AS IDTEKNISA,
                                     USR_CONTCTBL_IMPOSTO(IT.CDFILIAL, IT.NRLANCTONF, IT.CDIMPOSTO) AS CDCONTCTBL,
                                     IT.CDIMPOSTO AS PRODUTO,
                                     '' AS NMPRODUTO,
                                     IT.VRBASECALCIT AS MONTO,
                                     IT.VRALIQITEM AS IMPUESTO,
                                     IT.VRIMPOSTOIT AS MONTO_IMP,
                                     0 AS QTDEPROD,
                                     0 AS VRUNIT,
                                     LPAD(' ',4,' ') AS BODEGA,
                                     '' AS IDALMOXARIFE
                                  FROM ITEMPROIMPOS IT
                                  WHERE
                                     (IT.CDFILIAL    = C_SAIDA.CDFILIAL)     AND
                                     (IT.NRLANCTONF  = C_SAIDA.NRLANCTONF)   AND
                                     (IT.VRIMPOSTOIT <> 0)
                                 ) A
                              ORDER BY A.IDTEKNISA) N
                          UNION ALL
                          SELECT
                             C_SAIDA.ID,
                             IT.CDFILIAL||IT.NRLANCESTQ||IT.NRSEQUITEM AS IDTEKNISA,
                             USR_CONTCTBL_PROD(IT.CDFILIAL, ' ', IT.CDPRODUTO, PD.CDARVPROD) AS CDCONTCTBL,
                             V_CENTRO AS CENTRO,
                             PD.CDARVPROD AS PRODUTO,
                             PD.NMPRODUTO AS NMPRODUTO,
                             IT.VRTOTLANCTO AS MONTO,
                             0 AS IMPUESTO,
                             0 AS MONTO_IMP,
                             IT.QTLANCTOEST AS QTDEPROD,
                             IT.VRUNILANCTO AS VRUNIT,
                             LPAD(IT.CDALMOXARIFE,4,' ') AS BODEGA,
                             C_SAIDA.CDFILIEMIT,
                             '' AS IDALMOXARIFE
                          FROM ITLANCTOEST IT, PRODUTO PD
                          WHERE
                             (IT.CDFILIAL   = C_SAIDA.CDFILIAL)    AND
                             (IT.NRLANCESTQ = C_SAIDA.NRLANCESTQ)  AND
                             (IT.CDPRODUTO  = PD.CDPRODUTO)
                          UNION ALL
                          SELECT
                             C_SAIDA.ID,
                             IT.CDFILIAL||IT.NRLANCTONF||IT.CDIMPOSTO||IT.NRIMPOSNF AS IDTEKNISA,
                             USR_CONTCTBL_IMPOSTO(IT.CDFILIAL, IT.NRLANCTONF, IT.CDIMPOSTO) AS CDCONTCTBL,
                             V_CENTRO AS CENTRO,
                             IT.CDIMPOSTO AS PRODUTO,
                             '' AS NMPRODUTO,
                             IT.VRBASECALCNF AS MONTO,
                             IT.VRALIQNF AS IMPUESTO,
                             IT.VRIMPOSTONF AS MONTO_IMP,
                             0 AS QTDEPROD,
                             0 AS VRUNIT,
                             LPAD(' ',4,' ') AS BODEGA,
                             C_SAIDA.CDFILIEMIT,
                             '' AS IDALMOXARIFE
                          FROM IMPOSTONF IT, IMPOSTO I
                          WHERE
                             (IT.CDFILIAL    = C_SAIDA.CDFILIAL)     AND
                             (IT.NRLANCTONF  = C_SAIDA.NRLANCTONF)   AND
                             (IT.VRIMPOSTONF <> 0)                   AND
                             (I.CDIMPOSTO    = IT.CDIMPOSTO)         AND
                             (I.IDPRODNOTA   = 'C')
                          UNION ALL
                          SELECT
                             C_SAIDA.ID,
                             IT.CDFILIAL||IT.NRLANCTONF||IT.CDENCARGO AS IDTEKNISA,
                             USR_CONTCTBL_ENCARGO(IT.CDFILIAL, IT.NRLANCTONF, IT.CDENCARGO) AS CDCONTCTBL,
                             V_CENTRO AS CENTRO,
                             '' AS PRODUTO,
                             '' AS NMPRODUTO,
                             IT.VRITEMENCA AS MONTO,
                             0 AS IMPUESTO,
                             0 AS MONTO_IMP,
                             0 AS QTDEPROD,
                             0 AS VRUNIT,
                             LPAD(' ',4,' ') AS BODEGA,
                             C_SAIDA.CDFILIEMIT,
                             '' AS IDALMOXARIFE
                          FROM ITEMENCARGO IT
                          WHERE
                             (IT.CDFILIAL      = C_SAIDA.CDFILIAL)    AND
                             (IT.NRLANCTONF    = C_SAIDA.NRLANCTONF)  AND
                             (IT.CDENCARGO     in ('01','02'))        AND
                             (IT.VRITEMENCA   <> 0)                   AND
                             (C_SAIDA.CDPAIS   = '0056')
                         )
      LOOP
      
         IF C_ITEMSAIDA.IDALMOXARIFE = 'S' THEN
            V_BODEGA := C_ITEMSAIDA.BODEGA;
         ELSE
            V_BODEGA := C_ITEMSAIDA.CDFILIEMIT;
         END IF;

         /* Verifica sequencial (LINEA) para inserir na tabela NF_DETALLE_INTG */
         SELECT NVL(LPAD(TO_CHAR(TO_NUMBER(MAX(LINEA)) + 1),4,'0'),'0001')
           INTO V_LINEA
           FROM NF_DETALLE_INTG
          WHERE
             (ID = C_ITEMSAIDA.ID);

         INSERT INTO NF_DETALLE_INTG
             (ID, IDTEKNISA, LINEA, CUENTA, CENTRO, PRODUCTO, DESCRIPCION_CODIGO_ARBOL,
              MONTO, IMPUESTO, MONTO_IMP, CANTIDAD, VALOR_UNITARIO, BODEGA, FECHA_EXPORTAC)
         VALUES
             (C_ITEMSAIDA.ID, C_ITEMSAIDA.IDTEKNISA, V_LINEA,
              C_ITEMSAIDA.CDCONTCTBL, C_ITEMSAIDA.CENTRO, SUBSTR(C_ITEMSAIDA.PRODUTO,1,10),
              C_ITEMSAIDA.NMPRODUTO, SUBSTR(TO_CHAR(ROUND(C_ITEMSAIDA.MONTO,2)),1,20),
              SUBSTR(TO_CHAR(ROUND(C_ITEMSAIDA.IMPUESTO,2)),1,20), SUBSTR(TO_CHAR(ROUND(C_ITEMSAIDA.MONTO_IMP,2)),1,20),
              SUBSTR(TO_CHAR(ROUND(C_ITEMSAIDA.QTDEPROD,2)),1,20), SUBSTR(TO_CHAR(ROUND(C_ITEMSAIDA.VRUNIT,2)),1,20),
              V_BODEGA, SYSDATE);
      END LOOP;
      V_TOTAITENS := 0;
      SELECT COUNT(*)
        INTO V_TOTAITENS
        FROM NF_DETALLE_INTG
       WHERE ID = C_SAIDA.ID;

      IF V_TOTAITENS <= 0 THEN
         DELETE FROM NF_CABECERA_INTG
          WHERE ID = C_SAIDA.ID;
      END IF;
   END LOOP;

   V_LINEA := '';

   /* Grava posio de estoque por produto */

   FOR C_POSICAOEST IN (SELECT
                           (P.CDFILIAL||TO_CHAR(P_DTINICIAL, 'DDMMYYYY')||TP.CDEXTIPOOPER) AS ID,
                           P.CDFILIAL||P.CDPRODUTO AS IDTEKNISA,
                           USR_CONTCTBL_PROD(P.CDFILIAL, ' ', P.CDPRODUTO, PROD.CDARVPROD) AS CDCONTCTBL,
                           '' AS CENTRO,
                           PROD.CDARVPROD AS PRODUTO,
                           PROD.NMPRODUTO,
                           ROUND(SUM(P.VRESTOQDIA),2) AS MONTO,
                           0 AS IMPUESTO,
                           0 AS MONTO_IMP,
                           ROUND(SUM(P.QTESTOQDIA),2) AS QTDEPROD,
                           P.CDFILIAL
                        FROM POSESTDIA P, PRODUTO PROD, FILIAL F, TIPOOPERAC TP, ALMOXARIFADO A
                        WHERE
                           (P.CDFILIAL      = P_CDFILIAL)                                      AND
                           (P.CDFILIAL      = A.CDFILIAL)                                      AND
                           (P.CDALMOXARIFE  = A.CDALMOXARIFE)                                  AND
                           (P.NRLOTEESTQ    = ' ')                                             AND
                           (P.NRSUBLOTE     = ' ')                                             AND
                           (P.CDPRODUTO     = PROD.CDPRODUTO)                                  AND
                           (P.QTESTOQDIA <> 0)                                                 AND
                           (P.DTPOSIESTQ = (SELECT MAX(C.DTPOSIESTQ)
                                            FROM POSESTDIA C
                                            WHERE (C.CDFILIAL     = P.CDFILIAL)      AND
                                                  (C.CDPRODUTO    = P.CDPRODUTO)     AND
                                                  (C.CDALMOXARIFE = P.CDALMOXARIFE)  AND
                                                  (C.CDLOCALESTOQ = P.CDLOCALESTOQ)  AND
                                                  (C.NRLOTEESTQ   = P.NRLOTEESTQ)    AND
                                                  (C.NRSUBLOTE    = P.NRSUBLOTE)     AND
                                                  (C.DTPOSIESTQ <= TO_DATE(P_DTINICIAL + 1)))) AND
                           (F.CDFILIAL      = P.CDFILIAL)                                      AND
                           (TP.IDENTRSAIDOP = 'S')                                             AND
                           (TP.CDTIPOOPER   = '80')
                        GROUP BY
                           (P.CDFILIAL||TO_CHAR(P_DTINICIAL, 'DDMMYYYY')||TP.CDEXTIPOOPER),
                           P.CDFILIAL||P.CDPRODUTO,
                           USR_CONTCTBL_PROD(P.CDFILIAL, ' ', P.CDPRODUTO, PROD.CDARVPROD),
                           '',
                           PROD.CDARVPROD,
                           PROD.NMPRODUTO,
                           0,
                           0,
                           P.CDFILIAL
                       )
   LOOP
      /* Somente produtos que possuem valor em estoque */
      IF ((C_POSICAOEST.MONTO <> 0) AND (C_POSICAOEST.QTDEPROD <> 0)) THEN
         UPDATE NF_DETALLE_INTG
         SET CUENTA                   = SUBSTR(C_POSICAOEST.CDCONTCTBL,1,9),
             CENTRO                   = C_POSICAOEST.CENTRO,
             PRODUCTO                 = SUBSTR(C_POSICAOEST.PRODUTO,1,10),
             DESCRIPCION_CODIGO_ARBOL = C_POSICAOEST.NMPRODUTO,
             MONTO                    = SUBSTR(TO_CHAR(ROUND(C_POSICAOEST.MONTO,2)),1,20),
             IMPUESTO                 = SUBSTR(TO_CHAR(ROUND(C_POSICAOEST.IMPUESTO,2)),1,20),
             MONTO_IMP                = SUBSTR(TO_CHAR(ROUND(C_POSICAOEST.MONTO_IMP,2)),1,20),
             CANTIDAD                 = SUBSTR(TO_CHAR(ROUND(C_POSICAOEST.QTDEPROD,2)),1,20),
             BODEGA                   = C_POSICAOEST.CDFILIAL,
             FECHA_EXPORTAC			  = SYSDATE
         WHERE
            (IDTEKNISA = C_POSICAOEST.IDTEKNISA);

         IF SQL%ROWCOUNT = 0 THEN

            /* Verifica sequencial (LINEA) para inserir na tabela NF_DETALLE_INTG */
            SELECT NVL(LPAD(TO_CHAR(TO_NUMBER(MAX(LINEA)) + 1),4,'0'),'0001')
            INTO V_LINEA
            FROM NF_DETALLE_INTG
            WHERE
               (ID = C_POSICAOEST.ID);

            INSERT INTO NF_DETALLE_INTG
               (ID, IDTEKNISA, LINEA, CUENTA, CENTRO, PRODUCTO, DESCRIPCION_CODIGO_ARBOL,
                MONTO, IMPUESTO, MONTO_IMP, CANTIDAD, VALOR_UNITARIO, BODEGA, FECHA_EXPORTAC)
            VALUES
               (C_POSICAOEST.ID, C_POSICAOEST.IDTEKNISA, V_LINEA,
                C_POSICAOEST.CDCONTCTBL, C_POSICAOEST.CENTRO, SUBSTR(C_POSICAOEST.PRODUTO,1,10),
                C_POSICAOEST.NMPRODUTO, SUBSTR(TO_CHAR(ROUND(C_POSICAOEST.MONTO,2)),1,20),
                SUBSTR(TO_CHAR(ROUND(C_POSICAOEST.IMPUESTO,2)),1,20), SUBSTR(TO_CHAR(ROUND(C_POSICAOEST.MONTO_IMP,2)),1,20),
                SUBSTR(TO_CHAR(ROUND(C_POSICAOEST.QTDEPROD,2)),1,20), SUBSTR(TO_CHAR(ROUND((C_POSICAOEST.MONTO/C_POSICAOEST.QTDEPROD),2)),1,20),
                C_POSICAOEST.CDFILIAL, SYSDATE);
         END IF;
      END IF;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_TABELA_NF','5.85.XXX'); END;
/

